ompi/mca/ptl/llc/ptl_llc.h File Reference.TH "ompi/mca/ptl/llc/ptl_llc.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/llc/ptl_llc.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'opal/event/event.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'mca/ptl/ptl.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PTL_LLC_STATISTICS\fP   0"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_ptl_llc_component_t\fP \fBmca_ptl_llc_component_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_ptl_llc_module_t\fP \fBmca_ptl_llc_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_ptl_llc_component_open\fP (void)"
.br
.RI "\fIRegister LLC module parameters with the MCA framework. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_component_close\fP (void)"
.br
.RI "\fIAny final cleanup before being unloaded. \fP"
.ti -1c
.RI "\fBmca_ptl_base_module_t\fP ** \fBmca_ptl_llc_component_init\fP (int *num_ptls, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fILLC module initialization. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_component_control\fP (int param, void *value, size_t size)"
.br
.RI "\fILLC module control. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_component_progress\fP (mca_ptl_tstamp_t tstamp)"
.br
.RI "\fILLC module progress. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_finalize\fP (struct \fBmca_ptl_base_module_t\fP *ptl)"
.br
.RI "\fICleanup any resources held by the PTL. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_add_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers, struct ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_del_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_request_init\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.br
.RI "\fIPML->PTL Initialize a send request for LLC cache. \fP"
.ti -1c
.RI "void \fBmca_ptl_llc_request_fini\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.br
.RI "\fIPML->PTL Cleanup a send request that is being removed from the cache. \fP"
.ti -1c
.RI "void \fBmca_ptl_llc_matched\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *frag)"
.br
.RI "\fIPML->PTL Notification that a receive fragment has been matched. \fP"
.ti -1c
.RI "int \fBmca_ptl_llc_send\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL Initiate a send of the specified size. \fP"
.ti -1c
.RI "void \fBmca_ptl_llc_recv_frag_return\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_llc_recv_frag_t\fP *frag)"
.br
.RI "\fIReturn a recv fragment to the modules free list. \fP"
.ti -1c
.RI "void \fBmca_ptl_llc_send_frag_return\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_llc_send_frag_t\fP *)"
.br
.RI "\fIReturn a send fragment to the modules free list. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "struct OMPI_COMP_EXPORT \fBmca_ptl_llc_component_t\fP \fBmca_ptl_llc_component\fP"
.br
.ti -1c
.RI "\fBmca_ptl_llc_module_t\fP \fBmca_ptl_llc_module\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Function Documentation"
.PP 
.SS "int mca_ptl_llc_add_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers, struct ompi_bitmap_t * reachable)"
.PP
PML->PTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIpeers\fP (OUT) Set of (optional) peer addressing info. 
.br
\fIpeers\fP (IN/OUT) Set of processes that are reachable via this PTL. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "\fBmca_ptl_base_module_t\fP** mca_ptl_llc_component_init (int * num_ptls, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
LLC module initialization. 
.PP
\fBParameters:\fP
.RS 4
\fInum_ptls\fP (OUT) Number of PTLs returned in PTL array. 
.br
\fIallow_multi_user_threads\fP (OUT) Flag indicating wether PTL supports user threads (TRUE) 
.br
\fIhave_hidden_threads\fP (OUT) Flag indicating wether PTL uses threads (TRUE)
.RE
.PP
(1) read interface list from kernel and compare against module parameters then create a PTL instance for selected interfaces (2) setup LLC listen socket for incoming connection attempts (3) publish PTL addressing info 
.SS "int mca_ptl_llc_del_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers)"
.PP
PML->PTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fInproc\fP (IN) Number of processes. 
.br
\fIprocs\fP (IN) Set of processes. 
.br
\fIpeers\fP (IN) Set of peer data structures. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "int mca_ptl_llc_finalize (struct \fBmca_ptl_base_module_t\fP * ptl)"
.PP
Cleanup any resources held by the PTL. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP PTL instance. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "void mca_ptl_llc_matched (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_recv_frag_t\fP * frag)"
.PP
PML->PTL Notification that a receive fragment has been matched. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP (IN) Receive fragment 
.RE
.PP

.SS "void mca_ptl_llc_recv_frag_return (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_llc_recv_frag_t\fP * frag)"
.PP
Return a recv fragment to the modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIfrag\fP (IN) LLC receive fragment 
.RE
.PP

.SS "void mca_ptl_llc_request_fini (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.PP
PML->PTL Cleanup a send request that is being removed from the cache. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (IN) Pointer to allocated request. 
.RE
.PP

.SS "int mca_ptl_llc_request_init (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.PP
PML->PTL Initialize a send request for LLC cache. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (IN) Pointer to allocated request. 
.RE
.PP

.SS "int mca_ptl_llc_send (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_peer_t\fP * ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.PP
PML->PTL Initiate a send of the specified size. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIsend_request\fP (IN/OUT) Send request (initialized by PML via mca_ptl_base_request_init_fn_t) 
.br
\fIsize\fP (IN) Number of bytes PML is requesting PTL to deliver 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments 
.RE
.PP

.SS "void mca_ptl_llc_send_frag_return (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_llc_send_frag_t\fP *)"
.PP
Return a send fragment to the modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIfrag\fP (IN) LLC send fragment 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
